'---------------------------------------------------------------------------
'Subject:       Text to PDF Converter
'Author:        Peter Redei
'Date:          03/31/2004
'Credits:       Paras Chopra - Original code in VB
'               Aldos - some fixes in the VB code
'Public Domain submission.
'Notes:         Please feel free to improve it, such as adding graphic.
'---------------------------------------------------------------------------
'Filename:      Text2pdf.inc
'Compiler:      PBDLL 7.02
'---------------------------------------------------------------------------
Type PDFDATA
    pageHeight      As Long
    pageWidth       As Long
    BaseFont        As Asciiz * 40
    pointSize       As Long
    vertSpace       As Single
    rotation        As Long
    Lines           As Long
    linelen         As Single
    obj             As Long
    npagex          As Long
    npagey          As Long
    pageNo          As Long
    position        As Long
    cache           As Asciiz * 9000
    author          As Asciiz * 80
    creator         As Asciiz * 80
    keywords        As Asciiz * 512
    subject         As Asciiz * %MAX_PATH
    title           As Asciiz * %MAX_PATH
    textfile        As Asciiz * %MAX_PATH
    pdffile         As Asciiz * %MAX_PATH
    info            As Long
    Root            As Long
    tpages          As Long
    encoding        As Long
    resources       As Long
    lineNo          As Long
End Type
Global location()   As Long
Global pageObj()    As Long

%ERROR_INPUTFILEMISSING = -13001


Function FileExists(ByVal filename As String) As Long
    On Error Resume Next
    Function = (Dir$(filename) > "")
End Function


Sub writepdf(pdf As PDFDATA, sData As String, ByVal bflush As Long)
    Local w As Long
    On Error Resume Next
    pdf.position = pdf.position + Len(sData)
    pdf.cache = pdf.cache & sData & $Cr
    If Len(pdf.cache) > 8192 Or IsTrue(bflush) Then
        w = FreeFile
        Open pdf.pdffile For Append As #w
        Print #w, pdf.cache;
        Close #w
        pdf.cache = ""
    End If
End Sub

Sub EndPDFPage(pdf As PDFDATA, streamstart As Long)
    Local streamEnd As Long
Try
    writepdf pdf, "ET", %false
    streamEnd = pdf.position
    writepdf pdf, "endstream", %false
    writepdf pdf, "endobj", %false
    Incr pdf.obj
    If pdf.obj > UBound(location) Then ReDim Preserve location(pdf.obj)
    location(pdf.obj) = pdf.position
    writepdf pdf, Format$(pdf.obj) & " 0 obj", %false
    writepdf pdf, Format$(streamEnd - streamstart), %false
    writepdf pdf, "endobj", %false
    pdf.lineNo = 0
Catch
    MsgBox Format$(Err) & " in EndPdfPage"
End Try
End Sub

Function StartPDFPage(pdf As PDFDATA) As Long

Try
    Incr pdf.obj
    If pdf.obj > UBound(location) Then ReDim Preserve location(pdf.obj)
    location(pdf.obj) = pdf.position
    Incr pdf.pageNo
    If pdf.pageNo > UBound(pageObj) Then ReDim Preserve pageObj(pdf.pageNo)
    pageObj(pdf.pageNo) = pdf.obj

    writepdf pdf, Format$(pdf.obj) & " 0 obj", %false
    writepdf  pdf, "<<", %false
    writepdf  pdf, "/Type /Page", %false
    writepdf  pdf, "/Parent " & Format$(pdf.tpages) & " 0 R", %false
    writepdf  pdf, "/Resources " & Format$(pdf.resources) & " 0 R", %false

    Incr pdf.obj
    writepdf pdf, "/Contents " & Format$(pdf.obj) & " 0 R", %false
    writepdf pdf, "/Rotate " & Format$(pdf.rotation), %false
    writepdf pdf, ">>", %false
    writepdf pdf, "endobj", %false

    If pdf.obj > UBound(location) Then ReDim Preserve location(pdf.obj)
    location(pdf.obj) = pdf.position
    writepdf pdf, Format$(pdf.obj) & " 0 obj", %false
    writepdf  pdf, "<<", %false
    writepdf pdf, "/Length " & Format$(pdf.obj + 1) & " 0 R", %false
    writepdf pdf, ">>" , %false
    writepdf pdf, "stream", %false
    Function = pdf.position
    writepdf pdf, "BT", %false
    writepdf pdf, "/F1 " & Format$(pdf.pointSize) & " Tf", %false
    writepdf pdf, "1 0 0 1 50 " & Format$(pdf.pageHeight - 40) & " Tm", %false
    writepdf pdf, Format$(pdf.vertSpace) & " TL", %false
Catch
    MsgBox Format$(Err) & " in StartPdfPage"
End Try
End Function
Sub WritePages(pdf As PDFDATA)
    Local i As Long
    Local v As Long
    Local sLine As String, tmpline As String, beginstream As Long
Try
    v = FreeFile
    Open pdf.textfile For Input Access Read As #v
    beginstream = StartPDFPage(pdf)
    pdf.lineNo = -1
    Do Until Eof(v)
        Line Input #v, sLine
        Incr pdf.lineNo

        'page break
        If pdf.lineNo >= pdf.Lines Or InStr(sLine, $Ff) > 0 Then
            writepdf pdf, "1 0 0 1 " & Format$(pdf.npagex) & " " & Format$(pdf.npagey) & " Tm", %false
            writepdf pdf, "(" & Format$(pdf.pageNo) & ") Tj", %false
            writepdf pdf, "/F1 " & Format$(pdf.pointSize) & " Tf", %false
            EndPDFPage pdf, beginstream
            beginstream = StartPDFPage(pdf)
        End If

        Replace "(" With "\(" In sLine
        Replace ")" With "\)" In sLine
        sline = Trim$(sline)

        If Len(sLine) > pdf.linelen Then
            'word wrap
            Do While Len(sLine) > pdf.linelen
                tmpline = Left$(sLine, pdf.linelen)
                For i = Len(tmpline) To Len(tmpline) \ 2 Step -1
                    If InStr("*&^%$#,. ;<=>[])}!""", Mid$(tmpline, i, 1)) Then
                        tmpline = Left$(tmpline, i)
                        Exit For
                    End If
                Next
                sLine = Mid$(sLine, Len(tmpline) + 1)
                writepdf pdf, "T* (" & tmpline & $CrLf & ") Tj", %false
                Incr pdf.lineNo
                'page break
                If pdf.lineNo >= pdf.Lines Or InStr(sLine, $Ff) > 0 Then
                    writepdf pdf, "1 0 0 1 " & Format$(pdf.npagex) & " " & Format$(pdf.npagey) & " Tm", %false
                    writepdf pdf, "(" & Format$(pdf.pageNo) & ") Tj", %false
                    writepdf pdf, "/F1 " & Format$(pdf.pointSize) & " Tf", %false
                    EndPDFPage pdf, beginstream
                    beginstream = StartPDFPage(pdf)
                End If
            Loop
            Incr pdf.lineNo
            writepdf pdf, "T* (" & sLine & $CrLf & ") Tj", %false
        Else
            writepdf pdf, "T* (" & sLine & $CrLf & ") Tj", %false
        End If
    Loop
    Close #v
    writepdf pdf, "1 0 0 1 " & Format$(pdf.npagex) & " " & Format$(pdf.npagey) & " Tm", %false
    writepdf pdf, "(" & Format$(pdf.pageNo) & ") Tj", %false
    writepdf pdf, "/F1 " & Format$(pdf.pointSize) & " Tf", %false
    EndPDFPage pdf, beginstream
Catch
    MsgBox Format$(Err) & " in WritePages"
    Close
End Try
End Sub

Sub EndPdf(pdf As PDFDATA)
    Local ty As String, i As Integer, xreF As Long
Try
    If pdf.Root > UBound(location) Then ReDim Preserve location(pdf.Root)
    location(pdf.Root) = pdf.position
    writepdf pdf, Format$(pdf.Root) & " 0 obj", %false
    writepdf pdf, "<<", %false
    writepdf pdf, "/Type /Catalog", %false
    writepdf pdf, "/Pages " & Format$(pdf.tpages) & " 0 R", %false
    writepdf pdf, ">>", %false
    writepdf pdf, "endobj", %false
    If pdf.tpages > UBound(location) Then ReDim Preserve location(pdf.tpages)
    location(pdf.tpages) = pdf.position
    writepdf pdf, Format$(pdf.tpages) & " 0 obj", %false
    writepdf pdf, "<<", %false
    writepdf pdf, "/Type /Pages", %false
    writepdf pdf, "/Count " & Format$(pdf.pageNo), %false
    writepdf pdf, "/MediaBox [ 0 0 " & Format$(pdf.pageWidth) & " " & Format$(pdf.pageHeight) & " ]", %false
    ty = "/Kids [ "
    For i = 1 To pdf.pageNo
        ty = ty & Format$(pageObj(i)) & " 0 R "
    Next
    ty = ty & "]"
    writepdf pdf, ty, %false
    writepdf pdf, ">>", %false
    writepdf pdf, "endobj", %false
    xreF = pdf.position
    writepdf pdf, "0 " & Format$(pdf.obj + 1), %false
    writepdf pdf, "0000000000 65535 f ", %false
    For i = 1 To pdf.obj
      writepdf pdf, Format$(location(i), "0000000000") & " 00000 n ", %false
    Next
    writepdf pdf, "trailer", %false
    writepdf pdf, "<<", %false
    writepdf pdf, "/Size " & Format$(pdf.obj + 1), %false
    writepdf pdf, "/Root " & Format$(pdf.Root) & " 0 R", %false
    writepdf pdf, "/Info " & Format$(pdf.info) & " 0 R", %false
    writepdf pdf, ">>", %false
    writepdf pdf, "startxref", %false
    writepdf pdf, Format$(xreF), %false
    writepdf pdf, "%%EOF", %True
Catch
    MsgBox Format$(Err) & " in EndPdf"
End Try
End Sub
Function GetNow() As String
    Local sDate As String
    Local sTime As String

    sDate = Date$
    sTime = Time$
    Replace ":" With "" In sTime
    Function = Format$(2000 + Val(Mid$(sDate, 7, 2))) & Mid$(sDate, 1, 2) & Mid$(sDate, 4, 2) & sTime
End Function

Sub WriteHead(pdf As PDFDATA)
    Local CreationDate As String
Try
    CreationDate = "D:" & GetNow
    Incr pdf.obj
    If pdf.obj > UBound(location) Then ReDim Preserve location(pdf.obj)
    location(pdf.obj) = pdf.position
    pdf.info = pdf.obj

    writepdf pdf, Format$(pdf.obj) & " 0 obj", %false
    writepdf pdf, "<<", %false
    writepdf pdf, "/Author (" & pdf.author & ")", %false
    writepdf pdf, "/CreationDate (" & CreationDate & ")", %false
    writepdf pdf, "/Creator (" & pdf.creator & ")", %false
    writepdf pdf, "/Producer (PB_PDF)", %false
    writepdf pdf, "/Title (" & pdf.title & ")", %false
    writepdf pdf, "/Subject (" & pdf.subject & ")", %false
    writepdf pdf, "/Keywords (" & pdf.keywords & ")", %false
    writepdf pdf, ">>", %false
    writepdf pdf, "endobj", %false

    Incr pdf.obj
    pdf.Root = pdf.obj
    Incr pdf.obj
    pdf.tpages = pdf.obj
    pdf.encoding = pdf.obj + 2
    pdf.resources = pdf.obj + 3

    Incr pdf.obj
    If pdf.obj > UBound(location) Then ReDim Preserve location(pdf.obj)
    location(pdf.obj) = pdf.position
    writepdf pdf, Format$(pdf.obj) & " 0 obj", %false
    writepdf pdf, "<<", %false
    writepdf pdf, "/Type /Font", %false
    writepdf pdf, "/Subtype /Type1", %false
    writepdf pdf, "/Name /F1", %false
    writepdf pdf, "/Encoding " & Format$(pdf.encoding) & " 0 R", %false
    writepdf pdf, "/BaseFont /" & pdf.BaseFont, %false
    writepdf pdf, ">>", %false
    writepdf pdf, "endobj", %false

    Incr pdf.obj
    If pdf.obj > UBound(location) Then ReDim Preserve location(pdf.obj)
    location(pdf.obj) = pdf.position
    writepdf pdf, Format$(pdf.obj) & " 0 obj", %false
    writepdf pdf, "<<", %false
    writepdf pdf, "/Type /Encoding", %false
    writepdf pdf, "/BaseEncoding /WinAnsiEncoding", %false
    writepdf pdf, ">>", %false
    writepdf pdf, "endobj", %false

    Incr pdf.obj
    If pdf.obj > UBound(location) Then ReDim Preserve location(pdf.obj)
    location(pdf.obj) = pdf.position
    writepdf pdf, Format$(pdf.obj) & " 0 obj", %false
    writepdf pdf, "<<", %false
    writepdf pdf, "  /Font << /F1 " & Format$(pdf.obj - 2) & " 0 R >>", %false
    writepdf pdf, "  /ProcSet [ /PDF /Text ]", %false
    writepdf pdf, ">>", %false
    writepdf pdf, "endobj", %false
Catch
    MsgBox Format$(Err) & " in WriteHead"
End Try
End Sub
Sub WriteStart(pdf As PDFDATA)
    writepdf pdf, "%PDF-1.2", %false
    writepdf pdf, "%a~IO", %false
End Sub
Function TextToPDF Alias "TextToPDF"(ByVal sTextFile As String, _
                 ByVal sPDFFile As String, _
                 ByVal sAuthor As String, _
                 ByVal sCreator As String, _
                 ByVal sKeywords As String, _
                 ByVal sSubject As String, _
                 ByVal sTitle As String, _
                 ByVal sFontName As String, _
                 ByVal lngFontSize As Long, _
                 ByVal lngRotation As Long, _
                 ByVal sngPageWidth As Single, _
                 ByVal sngPageHeight As Single) Export As Long

    Local pdf As PDFDATA

Try
    If IsFalse FileExists(sTextFile) Then Function = %ERROR_INPUTFILEMISSING: Exit Function
    If IsTrue FileExists(sPDFFile) Then Kill sPDFFile

    pdf.author          = sAuthor
    pdf.creator         = sCreator
    pdf.keywords        = sKeywords
    pdf.subject         = sSubject
    pdf.title           = sTitle
    pdf.textfile        = sTextFile
    pdf.pdffile         = sPDFFile

    ReDim location(1 To 5000)
    ReDim pageObj(1 To 5000)

    If sngPageHeight = 0 Then pdf.pageHeight = 72 * 11 Else pdf.pageHeight = 72 * sngPageHeight
    If sngPageWidth = 0 Then pdf.pageWidth = 72 * 8.5 Else pdf.pageWidth = 72 * sngPageWidth
    If Len(sFontName) = 0 Then
        pdf.BaseFont = "Arial"
    Else
        pdf.BaseFont = sFontName      ' Courier, Times-Roman, Arial
    End If
    If lngFontSize = 0 Then pdf.pointSize = 10 Else pdf.pointSize = lngFontSize      ' Font Size; Don't change it
    pdf.vertSpace     = pdf.pointSize * 1.2             ' Vertical spacing
    pdf.rotation      = lngRotation                   ' degrees to rotate; try setting 90,180,etc
    pdf.Lines = (pdf.pageHeight - 72) / pdf.vertSpace  ' no of lines on one page

    Select Case LCase$(pdf.BaseFont)
        Case "courier": pdf.linelen = 1.5 * pdf.pageWidth / pdf.pointSize
        Case "arial": pdf.linelen = 2 * pdf.pageWidth / pdf.pointSize
        Case Else: pdf.linelen = 2.2 * pdf.pageWidth / pdf.pointSize
    End Select

    pdf.obj             = 0
    pdf.npagex          = pdf.pageWidth / 2
    pdf.npagey          = 25
    pdf.pageNo          = 0
    pdf.position        = 0
    pdf.cache           = ""
    pdf.info            = 0

    WriteStart pdf
    WriteHead pdf
    WritePages pdf
    EndPdf pdf
Catch

End Try
End Function
